//+------------------------------------------------------------------+
//|                                                       SL_DEV.mq4 |
//|                               Copyright  2011, Vladimir Hlystov |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, Vladimir Hlystov"
#property link      "cmillion@narod.ru"
 
#property indicator_chart_window
#property  indicator_buffers 4
#property  indicator_color1  Blue
#property  indicator_color2  Red
#property  indicator_color3  Red
#property  indicator_color4  Blue
 
//+------------------------------------------------------------------+
extern int    Period_DEV     = 14;
extern int    Price_DEV      = PRICE_CLOSE; 
extern double Multiplier_DEV = 1;
//+------------------------------------------------------------------+
double SLSell[],SLBay[];
double     BufferBuy[];
double     BufferSell[];
//+------------------------------------------------------------------+
int init()
  {
//---- drawing settings
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexArrow(2,234);
   SetIndexStyle(3,DRAW_ARROW);
   SetIndexArrow(3,233);
//---- indicator buffers mapping
   SetIndexBuffer(0,SLSell);
   SetIndexBuffer(1,SLBay);
   SetIndexBuffer(2,BufferBuy);
   SetIndexBuffer(3,BufferSell);
//---- name for DataWindow and indicator subwindow label
   SetIndexLabel(0,"SL Sell ");
   SetIndexLabel(1,"SL Bay ");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars = IndicatorCounted();      
   if(counted_bars > 0) counted_bars--;
   int limit = Bars-counted_bars;
   for(int i=limit-1; i>=0; i--) 
   {
      double DEV = Multiplier_DEV*iEDev(iMA(NULL,0,1,0,MODE_SMA,Price_DEV,i),Period_DEV,i);
      if (NormalizeDouble(High[i] + DEV,Digits)<=SLBay[i+1] || SLBay[i+1]==EMPTY_VALUE) SLBay[i]  = NormalizeDouble(High[i] + DEV,Digits);
      //else SLBay[i]=SLBay[i+1];
      if (High[i]>=SLBay[i]) SLBay[i]=EMPTY_VALUE;
      if (SLBay[i+2]==EMPTY_VALUE && SLBay[i+1]>=SLBay[i] && SLBay[i]!=EMPTY_VALUE) BufferBuy[i+1]=SLBay[i+1];
      
      if (NormalizeDouble(Low[i]  - DEV,Digits)>=SLSell[i+1] || SLSell[i+1]==EMPTY_VALUE) SLSell[i] = NormalizeDouble(Low[i]  - DEV,Digits);
      //else SLSell[i]=SLSell[i+1];
      if (Low[i]<=SLSell[i]) SLSell[i]=EMPTY_VALUE;
      if (SLSell[i+2]==EMPTY_VALUE && SLSell[i+1]<=SLSell[i] && SLSell[i]!=EMPTY_VALUE) BufferSell[i+1]=SLSell[i+1];
   }
   return(0);
  }
//+------------------------------------------------------------------+

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double edevWork[][2];
double iEDev(double price,double period, int i)
{
   if (ArrayRange(edevWork,0)!=Bars) ArrayResize(edevWork,Bars);
   
   int    r     = Bars-i-1;
   double alpha = 2.0/(1.0+period);
      
      edevWork[r][0] = edevWork[r-1][0]+alpha*(price      -edevWork[r-1][0]);
      edevWork[r][1] = edevWork[r-1][1]+alpha*(price*price-edevWork[r-1][1]);
         
   return(MathSqrt(period*(edevWork[r][1]-edevWork[r][0]*edevWork[r][0])/(period-1.0)));
}